/*
lesen und verwalten mehrerer Soundfiles und Buffer

*/



SF {
	
	var <>file, <>name, <>buffer, <>bufnum, <>size, <>numChannels, <>dur, <>sr, <num, server;
	
	*new { arg serv;
		^super.new.init(serv);
	}
		
	init { arg serv;
	
		server = serv ? Server.default;
		if (server.serverRunning.not) { "Warning: server not running".postln };
		num = nil;
		file = List.new;
		name = List.new;
		buffer = List.new;
		bufnum = List.new;
		size = List.new;
		numChannels = List.new;
		dur = List.new;
		sr = List.new;
		name = Dictionary.new;				 
		num 	= 	0;	
		// wenn kein Rueckgabeoperator (^), dann wird this zurueckgegeben, hier also eine Instanz von SF					 	
	}
	
	add { arg pathname;
		
		file.add(SoundFile.new);
		buffer.add(Buffer.read(server, pathname));
		if(file.at(num).openRead(pathname)) 
			{	bufnum.add(buffer.at(num).bufnum);
				size.add(file.at(num).numFrames);
				sr.add(file.at(num).sampleRate);
				numChannels.add(file.at(num).numChannels);
				dur.add(size.at(num) / sr.at(num));
				name.add(PathName(pathname).fileName.asSymbol -> num);
				file.at(num).close;
				(pathname ++ " gelesen!").postln;
				num = num + 1;		                    
			}
			{
			("Error: " ++ pathname ++ " konnte nicht gelesen werden!").postln;
			};	
	}
	
	
	addMany { arg path, names;
	
		names.do({arg fname, n; this.add(path ++ fname) });

	}
	
	test { arg n, loop=0;
		
		if (n < num) {
			{var sig; 
			sig = PlayBuf.ar(this.numChannels[n], this.bufnum[n], BufRateScale.kr(this.bufnum[n]), loop: loop);
			FreeSelfWhenDone.kr(sig);
			sig;	
			}.play(server);
		};	
	
	}
	
	 
}
	
	